﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=13
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private txtServerIP As EditText
	Private txtPortNumber As EditText
	Private txtDatabaseName As EditText
	Private txtDatabaseUserName As EditText
	Private txtDatabaseUserPassword As EditText
	Private txtHandSetID As EditText
	
	Public kvs As KeyValueStore

	Dim IME As IME
	
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("ApplicationSettings")
	
	btnClear_Click
	
	LoadDataFromLocalFile
	txtServerIP.RequestFocus	
	IME.Initialize("IME")

End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub txtServerIP_TextChanged (Old As String, New As String)
	IME.SetCustomFilter(txtServerIP, txtServerIP.INPUT_TYPE_NUMBERS, "0123456789.")
End Sub

Private Sub txtServerIP_EnterPressed
	
End Sub

Private Sub txtPortNumber_EnterPressed
	
End Sub

Private Sub txtDatabaseName_EnterPressed
	
End Sub

Private Sub txtDatabaseUserName_EnterPressed
	
End Sub

Private Sub txtDatabaseUserPassword_EnterPressed
	
End Sub

Private Sub txtHandSetID_EnterPressed
	
End Sub

Private Sub btnClear_Click
	txtServerIP.Text = ""
	txtServerIP.RequestFocus
	txtPortNumber.Text = ""
	txtDatabaseName.Text = ""
	txtDatabaseUserName.Text = ""
	txtDatabaseUserPassword.Text = ""
	txtHandSetID.Text = ""
	
End Sub

Private Sub btnSave_Click
	Dim ValdOption As Boolean = IsValidIp(txtServerIP.Text)

	If ValdOption = True Then
		kvs.Put("ServerIP", txtServerIP.Text)
		kvs.Put("ServerPort", txtPortNumber.Text)
		kvs.Put("DatabaseName", txtDatabaseName.Text)
		kvs.Put("UserName", txtDatabaseUserName.Text)
		kvs.Put("UserPassword", txtDatabaseUserPassword.Text)
		kvs.Put("HandsetID", txtHandSetID.Text)
		
		xui.MsgboxAsync("Settings Saved", Global.AppName)
	Else
		'show message to say ivalid IP address format entered
		xui.MsgboxAsync("Error Found in IP address. please check it", Global.AppName)
	End If	
End Sub


Private Sub LoadDataFromLocalFile
	xui.SetDataFolder("kvs")
	kvs.Initialize(xui.DefaultFolder, "kvs.dat")

	'fetch this value
	Dim DataToUse As String = ""
	
	DataToUse = kvs.Get("ServerIP") 
	If DataToUse.Length > 0 Then txtServerIP.Text = DataToUse
	
	DataToUse = kvs.Get("ServerPort")
	If DataToUse.Length > 0 Then txtPortNumber.Text = DataToUse
	
	DataToUse = kvs.Get("DatabaseName")
	If DataToUse.Length > 0 Then txtDatabaseName.Text = DataToUse
	
	DataToUse = kvs.Get("UserName")
	If DataToUse.Length > 0 Then txtDatabaseUserName.Text = DataToUse
	
	DataToUse = kvs.Get("UserPassword")
	If DataToUse.Length > 0 Then txtDatabaseUserPassword.Text = DataToUse
	
	DataToUse = kvs.Get("HandsetID")
	If DataToUse.Length > 0 Then txtHandSetID.Text = DataToUse
	  
	txtServerIP.RequestFocus
End Sub

Sub IsValidIp(ip As String) As Boolean
	Dim m As Matcher
	m = Regex.Matcher("^(\d+)\.(\d+)\.(\d+)\.(\d+)$", ip)
	If m.Find = False Then Return False
	For i = 1 To 4
		If m.Group(i) > 255 Or m.Group(i) < 0 Then Return False
	Next
	Return True
End Sub

